<?php


/**
 * Dial plan class
 * show all dialplan entries
 */

class Dialplan {
	//Search for the dial plan entries, that match the "search" criterias
	function filter($ba,$span,$start,$navi=false){
		$where="";
		if ((!isset($_GET['dir']) || $_GET['dir']=='all' || $_GET['dir']=="") && $_GET['search']==""){
				$where = "";
		}else if ((!isset($_GET['dir']) || $_GET['dir']=='all' || $_GET['dir']=="") && $_GET['search']!=""){
				$where = ' 	WHERE fromId like ("%'.sqlite_escape_string($_GET["search"]).'%")
								or toId like ("%'.sqlite_escape_string($_GET["search"]).'%")
								or dest like ("%'.sqlite_escape_string($_GET["search"]).'%")
								or newDest like ("%'.sqlite_escape_string($_GET["search"]).'%")
								or src like ("%'.sqlite_escape_string($_GET["search"]).'%")
								or comment like ("%'.sqlite_escape_string($_GET["search"]).'%")
								or newSrc like ("%'.sqlite_escape_string($_GET["search"]).'%")';
			}else if (isset($_GET['dir']) && $_GET['dir']!='all' && $_GET['dir']!="" && $_GET['search']!=""){
				$dir=explode("-",$_GET['dir']);
				$where = ' 	WHERE (fromId like ("%'.sqlite_escape_string($_GET["search"]).'%")
								or toId like ("%'.sqlite_escape_string($_GET["search"]).'%")
								or dest like ("%'.sqlite_escape_string($_GET["search"]).'%")
								or newDest like ("%'.sqlite_escape_string($_GET["search"]).'%")
								or src like ("%'.sqlite_escape_string($_GET["search"]).'%")
								or comment like ("%'.sqlite_escape_string($_GET["search"]).'%")
								or newSrc like ("%'.sqlite_escape_string($_GET["search"]).'%"))
								and (toDirection="'.sqlite_escape_string($dir[1]).'" and fromDirection="'.sqlite_escape_string($dir[0]).'")';
			}else{
				$dir=explode("-",$_GET['dir']);
				$where = ' WHERE toDirection="'.sqlite_escape_string($dir[1]).'" and fromDirection="'.sqlite_escape_string($dir[0]).'" ';
			}
			//Select all entries for navigation bar whithout limit
			if (!$navi)
				$limit='limit ' . sqlite_escape_string($span) .' offset ' . sqlite_escape_string($start);

			$query = $ba->select(' SELECT * from dialplan '.$where.' ORDER BY posId, id asc '.$limit);

			return $query;
	}

	/*
	 * Show the dialplan entries 
	 */
	function display() {

		include "./includes/functions.php";
		//Function for the pagination bar
		$functions = new functions();


		// args
		$m = $_GET['m'];
		$q = $_GET['q'];
		$m = $_GET['m'];
		$start = $_GET['start'];
		$next_del=0;
		$next_add=0;
		//ein neues Datenbankobjekt wird erzeugt.
		$ba = new beroAri();
		
		$query = $ba->select('SELECT * FROM dialplan');
		$record_count = sqlite_num_rows($query);
		$start = $start == '' ? 0 : $start;
		if (isset($_GET['ent'])) $ba->set('span',$_GET['ent']);
		if (!$ba->get('span')) $ba->set('span','15');
		$span=$ba->get('span');

		$next_del=$start;
		$test=$record_count/$span;
		$test=(int)$test;
		if ($record_count==0){
			$next_add=0;
		}else{
			$next_add=($test*$span);
		}

		if ($start+$span<$record_count){
			$next_del=$start;
		}else{
			$rest=$record_count%$span;
			if ($record_count%$span==1){
				$next_del=$start-$span;
				if ($next_del<0)$next_del=0;
			}else{
				$next_del=$start;
			}
		}

                $name="DIALPLAN_TITLE_DIS";
		include('./includes/header.php');
		$dialplan_table = $this->dynamic_table($next_del,$span,$next_add);
		// build page content
		$ret .= "<script type='text/javascript'>
				function popup(param,otonControl)
				{
					$.ajax({
						url : 'modules/Dialplan/dialplan_popup.php?'+param,
						success : function (data) {
							$('#dialog').html(data);

							$('#dialog').dialog({ minWidth: 670 });
							hide_elements(\"".DIALPLAN_FROM_ID_DIS."\",\"".DIALPLAN_MATCH_TYPE_DIS."\",otonControl);
							required();
						}
					});
				}

				function popupMore(param, from, to)
				{
					$.ajax({
						url : 'modules/Dialplan/more.php?'+param,
						success : function (data) {
							$('#dialog').html(data);

							$('#dialog').dialog({ minWidth: 700 });
							hide_elements(from+'-'+to); disable(); showdef();
						}
					});
				}

				function del(table,option, from, to,op,pos){


					conf = confirm('".DIALPLAN_DELETE_MESSAGE_DIS." ".DIALPLAN_FROM_ID_DIS." '+from+', ".DIALPLAN_TO_ID_DIS." '+to+'?');
					if (conf==false)
						return false;
					else
						window.location='./misc/delete.php?m=".$_GET['m']."&id='+option+'&table='+table+'&start='+pos;
				}
			</script>

			<div id='dialog' title='".DIALPLAN_TITLE_DIS."'></div>
			<br>
			<div id='content'>
			" . $dialplan_table . "
			<br>

			<form class='extensions_form' name='dialplan' action='' method='GET'>
			<input type=hidden name=m value='" . $m . "'>
			<input type=hidden name=f value='action'>
			<input type=hidden name=a value='add'>
			<input type=hidden name=start value='" . $next_add . "'>
			<div class='center'><input name='submit' type='button' value='".BUTTON_ADD."' onmouseover=\"Tip('" . DIALPLAN_MOD_INBOUND_ADD . "')\" onmouseout='UnTip()' onclick='popup(\"&start=" . $start . "&dir=" . $_GET['dir'] . "&search=" . $_GET['search'] . "\",\"false\");'><div><br>";

		//Create the pagination bar

		$url_opts = array ();
		$url_opts['number'] = $_GET['number'];
		$url_opts['search'] = $_GET['search'];
		$url_opts['dir'] = $_GET['dir'];
		$query=$this->filter($ba,$span,$start,true);
		$record_count = sqlite_num_rows($query);
		$ret .=$functions->displayNavigationBlock($m, $q, $url_opts, $start, $span, $record_count)."</form></div>";

		//Rückgabe: Inhalt der HTML-Seite
		return $ret;
	}
	
	function getDirFilter(){
		$directions=array("sip","isdn","analog","gsm","cas");
		$filter="<select name='dir' id='dir' onchange=\"window.location='index.php?m=".$_GET['m']."&search=".$_GET['search']."&dir='+getElementById('dir').options[getElementById('dir').selectedIndex].value;\">";
		if ($_GET['dir']=='all') $selected="selected";
		$filter.="<option value='all' $selected>".DIALPLAN_DIRECTION_ALL_DIS."</option>";
		foreach ($directions as $dir){
			foreach ($directions as $dir1){
				($_GET['dir']==$dir.'-'.$dir1) ? $selected="selected" : $selected="";
				$filter.="<option value='".$dir."-".$dir1."' $selected>".$dir."-".$dir1."</option>";
			}
				
		}
		$filter.="</select>";
		return $filter;
	}
	
	function getCountFilter($ba){
		$spancount=array(10,15,20,25,30,35,40,45,50);
		$filter="<select name='ent' id='ent' onchange=\"window.location='index.php?m=".$_GET['m']."&ent='+getElementById('ent').options[getElementById('ent').selectedIndex].value;\">";
		foreach ($spancount as $span){
			($ba->get('span')==$span) ? $selected="selected" : $selected="";
			$filter.="<option value='$span' $selected>$span</option>";
		}
		return $filter;
	}

	function dynamic_table($next_del,$span,$next_add) {
		$ba = new beroAri();
		require_once("./includes/lang.php");
		if($ba->get('gui_mode')=='simple') $simple_class='simple';
		$filter="<th colspan='12'>
		<form class='extensions_form'>
		".DIALPLAN_DIRECTION_DIS.": ".  $this->getDirFilter();

		$filter.="&nbsp;&nbsp;".DIALPLAN_SEARCH_DIS.": <input name='search' value='".$_GET['search']."' onkeydown=\"if (event.keyCode == 13){ window.location='index.php?m=".$_GET['m']."&dir=".$_GET['dir']."&search='+search.value; return false;}\" >";
		$filter.="&nbsp;&nbsp;
		".DIALPLAN_ENTRIES_DIS.": ". $this->getCountFilter($ba).
		"</form>
		</th>";




		$query = $ba->select(' SELECT * from dialplan ORDER BY posId, id asc');
		$pi = 1;

		while ($entry = $ba->fetch_array($query)) {
			$ba->update('UPDATE dialplan set posId="'.$pi++.'" WHERE id="'.$entry['id'].'"');
		}


		$start = $_GET['start'];
		$columns = $ba->column_type('dialplan');
		$i = 0;

		//Table header
		$cols.= "<th nowrap><input type='checkbox' id='checkall'>".DIALPLAN_CHECK_ALL_DIS."</th>";
		$cols.= "<th>".DIALPLAN_DIRECTION_DIS."</th>";
		foreach ($columns as $column => $type) {
			if (($column != 'id') && ($column != 'config') && ($column != 'isdnid') && ($column != 'activ') && ($column != 'fromDirection') && ($column != 'toDirection') && ($column != 'posId') && ($column != 'comment')) {
				$cols_name[$i] = $column;
				if ($column == "fromId")
					$cols .= "<th>" . DIALPLAN_FROM_ID_DIS . "</th>";
				if ($column == "toId")
					$cols .= "<th>" . DIALPLAN_TO_ID_DIS . "</th>";
				if ($column == "dest"){
					$cols .= "<th class='".$simple_class."'>" . DIALPLAN_DESTINATION_DIS . "</th>";
					$class[$column]=$simple_class;
				}
				if ($column == "newDest"){
					$cols .=  "<th class='".$simple_class."'>" . DIALPLAN_NEW_DESTINATION_DIS . "</th>";
					$class[$column]=$simple_class;
				}
				if ($column == "src"){
					$cols .= "<th class='".$simple_class."'>" . DIALPLAN_SOURCE_DIS . "</th>";
					$class[$column]=$simple_class;
				}
				if ($column == "newSrc"){
					$cols .= "<th class='".$simple_class."'>" . DIALPLAN_NEW_SOURCE_DIS . "</th>";
					$class[$column]=$simple_class;
				}
				$i++;
			}
		}
		$i = 0;
		$cols .= "<th>".DIALPLAN_POSITION_DIS."</th>";

		/*Table content, CRUD buttons*/
		$page = (($start / $span) + 1);
		if (!$start)
			$start = 0;
		$id = 0;

		for ($j = $page; $j <= $page; $j++) {
			$query=$this->filter($ba,$span,$start);
			$rows = '';

			while ($entry = $ba->fetch_array($query)) {

                                        
					($entry['activ']==1) ? $rows .= "<tr>" : $rows .= "<tr style='color:grey'>";
                                        $rows.="<td><form class='extensions_form' name='action' id='action".$entry['id']."' action=\"./modules/Dialplan/dialplan_action.php\">
                                                    <input type='checkbox' name='entryid' class='entryid' value='".$entry['id']."'/>
                                                    <input type='hidden' name='action' class='hiddenfield' value=''/>
						</form></td>";
					$rows.="<td>".$entry['fromDirection']."-".$entry['toDirection']."</td>";
					$count = sqlite_num_fields($query);
					for ($i = 0; $i < ($count - 8); $i++) {
						$col_name = $cols_name[$i];
						$entry['comment']=str_replace("\r\n","<br>",$entry['comment']);
						if ($entry['comment']!="") $rows .= "<td class='".$class[$col_name]."' onmouseover=\"Tip('" . $entry['comment'] . "')\" onmouseout='UnTip()'>";
						else $rows .= "<td class='".$class[$col_name]."'>";
						if (strlen($entry[$col_name])>15) $value=substr($entry[$col_name],0,15)."...";
						else $value=$entry[$col_name];
                                                //Don't show the matchtypes and g:
                                                if (strpos($value, ":")===1) $rows.=substr($entry[$col_name],2);
                                                else $rows.=$value;
						$rows.="</td>";
					}

					if ((!isset($_GET['dir']) || $_GET['dir']=='all' || $_GET['dir']=="") && $_GET['search']=="")
					$rows.="<td>
								<a href='modules/Dialplan/change_pos.php?posid=".($entry['posId']-1)."&id[]=".$entry['id']."'><img src='./includes/images/up.png' onmouseover=\"Tip('" .DIALPLAN_UP . "')\" onmouseout='UnTip()'></a>
								&nbsp;
								<a href='modules/Dialplan/change_pos.php?posid=".($entry['posId']+1)."&id[]=".$entry['id']."'><img src='./includes/images/down.png' onmouseover=\"Tip('" .DIALPLAN_DOWN . "')\" onmouseout='UnTip()'></a>
								&nbsp;
								<form class='extensions_form position' id='pos".$entry['id']."' action=\"./modules/Dialplan/change_pos.php\">
									<input type='text' name='posid' size='3' value='".$entry['posId']."' digits='true' onmouseover=\"Tip('" . DIALPLAN_MOVE_POS_DIS . "')\" onmouseout='UnTip()' onkeydown=\"if (event.keyCode == 13){ $('#pos".$entry['id']."').submit(); }\">
                                                                        <input type='hidden' name='id[]' value='".$entry['id']."'>
								</form>
                                                                <label id='posid".$entry['posId']."'></label>
                                                                <script>
                                                                    $(\"#pos".$entry['id']."\").validate({
                                                                        errorLabelContainer: \"#posid".$entry['posId']."\",
                                                                    });
                                                                </script>
							</td>";
					else
					$rows.="<td>
								<img src='./includes/images/up.png'>
								&nbsp;
								<img src='./includes/images/down.png'>
                                                                &nbsp;
								<form class='extensions_form position'>
									<input disabled type='text' name='pos' size='3' value='".$entry['posId']."' onmouseover=\"Tip('" . DIALPLAN_MOVE_POS_DIS . "')\" onmouseout='UnTip()'>
								</form>
							</td>";

					$id = $entry['id'];
					$rows .= "<td nowrap><font size='3'><form class='extensions_form'>
					<a class='popup_download' onclick=\"javascript:popup('id=" .
					$entry['id'] . "&start=" . $start . "&dir=" . $_GET['dir'] . "&search=" . $_GET['search'] . "','true')\" ><img src='./includes/images/modify.png' onmouseover=\"Tip('" .
					DIALPLAN_MOD_INBOUND_MODIFY . "')\" onmouseout='UnTip()'></a>" .
					"&nbsp;<a class='popup_download' onclick=\"javascript:popup('copy=" .
    	            $entry['id'] . "&start=" . $next_add . "&dir=" . $_GET['dir'] . "&search=" . $_GET['search'] . "','true')\" ><img src='./includes/images/copy.png' value='".BUTTON_COPY."' onmouseover=\"Tip('" .
        	        DIALPLAN_MOD_INBOUND_COPY . "')\" onmouseout='UnTip()'></a>" .
            	    "&nbsp;<a class='popup_download' onclick=\"del('dialplan','" . $id . "','".$entry['fromId']."','".$entry['toId']."','id','" .  $next_del . "');\"><img src='./includes/images/delete.png' onmouseover=\"Tip('" .
					DIALPLAN_MOD_INBOUND_DELETE . "')\" onmouseout='UnTip()'></a>" .
					"&nbsp;<a class='popup_download ".$simple_class."' onclick=\"javascript:popupMore('dialplanid=" .
					$entry['id'] . "&start=" . $start . "&dir=" . $_GET['dir'] . "&search=" . $_GET['search'] . "','".$entry['fromDirection']."','".$entry['toDirection']."' )\" ><img src='./includes/images/more.png' alt='more' onmouseover=\"Tip('" .
					DIALPLAN_MORE_OPTIONS . "')\" onmouseout='UnTip()'></a></form></font></td></tr>";
			}

		}
		//Table
		$table = "<table class='contenttoc' id='table'><tr>".$filter."</tr><tr>" . $cols . "<th></th></tr>" . $rows . "</table>
                        <img src='./includes/images/arrow.jpg' style='margin-left:50px; margin-right:5px;'>
                        <a href='javascript:void sendForm(\"activate\");'>activate</a> ,
                        <a href='javascript:void sendForm(\"deactivate\");'>deactivate</a> ,
                        <a href='javascript:void sendForm(\"delete\");'>delete</a>
                        <script>$(\"#checkall\").click(function(event) {
                                    if (this.checked){
                                        $('.entryid').each(function() { 
                                            this.checked = true;               
                                        });
                                    }else{
                                        $('.entryid').each(function() { 
                                            this.checked = false;               
                                        });
                                    }
                                    });
                                    

                                    function sendForm (action) {
                                        if (action=='delete'){
                                            Check = confirm('".DIALPLAN_DELETE_BULKMESSAGE_DIS."');
                                            if (Check == false)
                                                return false;  
                                        }
                                        $('.hiddenfield').each(function() { 
                                            $(\".hiddenfield\").val(action);
                                        });
                                    
                                        var entryid=[];
                                        var i=0;
                                        var action='';
                                        $('form[name=\"action\"]').each(function () {
                                            var \$form = $(this);
                                            if (\$form.find( \"input[name='entryid']\" ).prop('checked')==true) entryid[i++]=\$form.find( \"input[name='entryid']\" ).val();
                                            action=\$form.find( \"input[name='action']\" ).val();
                                            
                                             
                                        });
                                        $.post('./modules/Dialplan/dialplan_action.php', { entryid : entryid, action: action })
                                            .done (function (data) {
                                                location.reload();
                                            });
                                    }
                        </script>";  
		return $table;
	}

}
?>
